# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Class-Load-XS
Version:	0.10
Release:	20.%{__distinit}%{__distvers}
Summary:	XS implementation of parts of Class::Load
License:	Artistic-2.0
URL:		https://metacpan.org/release/Class-Load-XS
Source0:	https://cpan.metacpan.org/modules/by-module/Class/Class-Load-XS-%{version}.tar.gz
# ===================================================================
# Module build requirements
# ===================================================================
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# ===================================================================
# Module requirements
# ===================================================================
BuildRequires:	perl(Class::Load) >= 0.20
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# ===================================================================
# Regular test suite requirements
# ===================================================================
BuildRequires:	perl(constant)
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(Module::Implementation) >= 0.04
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Test::Needs)
BuildRequires:	perl(Test::Without::Module)
BuildRequires:	perl(version)
# ===================================================================
# Runtime requirements
# ===================================================================
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%{?perl_default_filter}

%description
This module provides an XS implementation for portions of Class::Load.
See Class::Load for API details.

%prep
%setup -q -n Class-Load-XS-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING README
%{perl_vendorarch}/auto/Class/
%{perl_vendorarch}/Class/
%{_mandir}/man3/Class::Load::XS.3*

%changelog
* Fri Mar 10 2023 Paul Howarth <paul@city-fan.org> - 0.10-20
- Use SPDX-format license tag

* Thu Jun  2 2022 Paul Howarth <paul@city-fan.org> - 0.10-18
- Perl 5.36 rebuild

* Mon May 24 2021 Paul Howarth <paul@city-fan.org> - 0.10-15
- Perl 5.34 rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 0.10-12
- Perl 5.32 rebuild

* Sat Jun  8 2019 Paul Howarth <paul@city-fan.org> - 0.10-9
- Perl 5.30 rebuild

* Fri Jun 29 2018 Paul Howarth <paul@city-fan.org> - 0.10-6
- Perl 5.28 rebuild

* Tue Aug  8 2017 Paul Howarth <paul@city-fan.org> - 0.10-4
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Wed Jun 14 2017 Paul Howarth <paul@city-fan.org> - 0.10-2
- Perl 5.26 rebuild

* Tue Apr 11 2017 Paul Howarth <paul@city-fan.org> - 0.10-1
- Update to 0.10
  - Fix test to handle altered Test::Without::Module exception message

* Fri Apr  7 2017 Paul Howarth <paul@city-fan.org> - 0.09-8
- Fix FTBFS with Test::Without::Module ≥ 0.19
  (https://github.com/moose/Class-Load/pull/2)
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop support for building with Test::More < 0.88
  - BR: perl-devel unconditionally

* Tue Aug  9 2016 Paul Howarth <paul@city-fan.org> - 0.09-6
- BR: perl-devel and perl-generators where available
- Simplify find commands using -empty and -delete

* Thu Nov 13 2014 Paul Howarth <paul@city-fan.org> - 0.09-1
- Updated to 0.09
  - Optimized some perl API calls

* Mon Sep 15 2014 Paul Howarth <paul@city-fan.org> - 0.08-4
- Drop support for building with ExtUtils::MakeMaker < 6.30
- Drop support for building without Test::Requires
- Use Test::Without::Module unconditionally
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Thu Feb 13 2014 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08:
  - Switched packaging to just EUMM, as MBT wants the .xs file in a different
    place
- Switch to ExtUtils::MakeMaker flow

* Thu Feb 13 2014 Paul Howarth <paul@city-fan.org> - 0.07-1
- Update to 0.07:
  - Repository moved to the github moose organization
- This release by ETHER -> update source URL
- Switch to Module::Build::Tiny flow
- Package upstream's CONTRIBUTING and README.md files
- Update patches as needed
- Don't bother with the author/release tests

* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 0.06-3
- Perl 5.18 rebuild

* Mon Oct  8 2012 Paul Howarth <paul@city-fan.org> - 0.06-1
- Update to 0.06:
  - Require Class::Load 0.20 in the code, not just the distro metadata
    (CPAN RT#80002)
  - Weird classes with either an ISA or VERSION constant would cause the XS to
    blow up badly (CPAN RT#79998)
  - Fixed some broken logic that lead to a segfault from the
    014-weird-constants.t test on some Perls (CPAN RT#80059)
- Bump perl(Class::Load) version requirement to 0.20
- Drop explicit requirement for perl(Class::Load), no longer needed
- Update patch for building with Test::More < 0.88

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> - 0.04-2
- BR: perl(lib) and perl(XSLoader)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Don't need to run the test suite with LC_ALL=C
  - Use %%{_fixperms} macro rather than PERL_INSTALL_ROOT

* Thu Feb  9 2012 Paul Howarth <paul@city-fan.org> - 0.04-1
- Update to 0.04:
  - Some small test changes for the latest Module::Implementation and
    Class::Load
- Bump Class::Load version requirement to 0.15
- BR: perl(constant), perl(Module::Implementation) ≥ 0.04,
  perl(Test::Requires), perl(Test::Without::Module) and perl(version) for test
  suite
- Add patch to work around absence of Test::Requires if necessary
- Update patch for building with Test::More < 0.88

* Fri Nov 18 2011 Paul Howarth <paul@city-fan.org> - 0.03-1
- Update to 0.03:
  - Explicitly include Test::Fatal as a test prerequisite (CPAN RT#72493)
- Update patch for building with Test::More < 0.88

* Wed Nov 16 2011 Paul Howarth <paul@city-fan.org> - 0.02-1
- Initial RPM version
